# ClpNetworkMatrix Class Reference

This implements a simple network matrix as derived from ClpMatrixBase. More...

`#include <ClpNetworkMatrix.hpp>`

Inheritance diagram for ClpNetworkMatrix:
[legend]
Collaboration diagram for ClpNetworkMatrix:
[legend]

List of all members.

## Public Member Functions
Useful methods
virtual CoinPackedMatrix * | getPackedMatrix () const
| Return a complete CoinPackedMatrix.
virtual bool | isColOrdered () const
| Whether the packed matrix is column major ordered or not.
virtual CoinBigIndex | getNumElements () const
| Number of entries in the packed matrix.
virtual int | getNumCols () const
| Number of columns.
virtual int | getNumRows () const
| Number of rows.
virtual const double * | getElements () const
| A vector containing the elements in the packed matrix.
virtual const int * | getIndices () const
| A vector containing the minor indices of the elements in the packed matrix.
virtual const CoinBigIndex * | getVectorStarts () const
| Return a complete CoinPackedMatrix.
virtual const int * | getVectorLengths () const
| The lengths of the major-dimension vectors.
virtual void | deleteCols (const int numDel, const int *indDel)
| Delete the columns whose indices are listed in `indDel`.
virtual void | deleteRows (const int numDel, const int *indDel)
| Delete the rows whose indices are listed in `indDel`.
virtual void | appendCols (int number, const CoinPackedVectorBase *const *columns)
| Append Columns.
virtual void | appendRows (int number, const CoinPackedVectorBase *const *rows)
| Append Rows.
virtual int | appendMatrix (int number, int type, const CoinBigIndex *starts, const int *index, const double *element, int numberOther=-1)
| Append a set of rows/columns to the end of the matrix.
virtual ClpMatrixBase * | reverseOrderedCopy () const
| Returns a new matrix in reverse order without gaps.
virtual CoinBigIndex | countBasis (const int *whichColumn, int &numberColumnBasic)
| Returns number of elements in column part of basis.
virtual void | fillBasis (ClpSimplex *model, const int *whichColumn, int &numberColumnBasic, int *row, int *start, int *rowCount, int *columnCount, CoinFactorizationDouble *element)
| Fills in column part of basis.
virtual CoinBigIndex * | dubiousWeights (const ClpSimplex *model, int *inputWeights) const
| Given positive integer weights for each row fills in sum of weights for each column (and slack).
virtual void | rangeOfElements (double &smallestNegative, double &largestNegative, double &smallestPositive, double &largestPositive)
| Returns largest and smallest elements of both signs.
virtual void | unpack (const ClpSimplex *model, CoinIndexedVector *rowArray, int column) const
| Unpacks a column into an CoinIndexedvector.
virtual void | unpackPacked (ClpSimplex *model, CoinIndexedVector *rowArray, int column) const
| Unpacks a column into an CoinIndexedvector in packed format Note that model is NOT const.
virtual void | add (const ClpSimplex *model, CoinIndexedVector *rowArray, int column, double multiplier) const
| Adds multiple of a column into an CoinIndexedvector You can use quickAdd to add to vector.
virtual void | add (const ClpSimplex *model, double *array, int column, double multiplier) const
| Adds multiple of a column into an array.
virtual void | releasePackedMatrix () const
| Allow any parts of a created CoinMatrix to be deleted.
virtual bool | canDoPartialPricing () const
| Says whether it can do partial pricing.
virtual void | partialPricing (ClpSimplex *model, double start, double end, int &bestSequence, int &numberWanted)
| Partial pricing.
Matrix times vector methods
virtual void | times (double scalar, const double *x, double *y) const
| Return `y + A * scalar *x` in `y`.
virtual void | times (double scalar, const double *x, double *y, const double *rowScale, const double *columnScale) const
| And for scaling.
virtual void | transposeTimes (double scalar, const double *x, double *y) const
| Return `y + x * scalar * A` in `y`.
virtual void | transposeTimes (double scalar, const double *x, double *y, const double *rowScale, const double *columnScale, double *spare=NULL) const
| And for scaling.
virtual void | transposeTimes (const ClpSimplex *model, double scalar, const CoinIndexedVector *x, CoinIndexedVector *y, CoinIndexedVector *z) const
| Return `x * scalar * A + y` in `z`.
virtual void | subsetTransposeTimes (const ClpSimplex *model, const CoinIndexedVector *x, const CoinIndexedVector *y, CoinIndexedVector *z) const
| Return `x *A` in `z` but just for indices in y.
Other
bool | trueNetwork () const
| Return true if really network, false if has slacks.
Constructors, destructor
| ClpNetworkMatrix ()
| Default constructor.
| ClpNetworkMatrix (int numberColumns, const int *head, const int *tail)
| Constructor from two arrays.
virtual | ~ClpNetworkMatrix ()
| Destructor.
Copy method
| ClpNetworkMatrix (const ClpNetworkMatrix &)
| The copy constructor.
| ClpNetworkMatrix (const CoinPackedMatrix &)
| The copy constructor from an CoinNetworkMatrix.
ClpNetworkMatrix & | operator= (const ClpNetworkMatrix &)
| The copy constructor.
virtual ClpMatrixBase * | clone () const
| Clone.
| ClpNetworkMatrix (const ClpNetworkMatrix &wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns)
| Subset constructor (without gaps).
virtual ClpMatrixBase * | subsetClone (int numberRows, const int *whichRows, int numberColumns, const int *whichColumns) const
| Subset clone (without gaps).
## Protected Attributes
Data members
The data members are protected to allow access for derived classes.
CoinPackedMatrix * | matrix_
| For fake CoinPackedMatrix.
int * | lengths_
| For fake CoinPackedMatrix.
int * | indices_
| Data -1, then +1 rows in pairs (row==-1 if one entry).
int | numberRows_
| Number of rows.
int | numberColumns_
| Number of columns.
bool | trueNetwork_
| True if all entries have two elements.

## Detailed Description

This implements a simple network matrix as derived from ClpMatrixBase.

If you want more sophisticated version then you could inherit from this. Also you might want to allow networks with gain

Definition at line 19 of file ClpNetworkMatrix.hpp.

## Constructor & Destructor Documentation

ClpNetworkMatrix::ClpNetworkMatrix | ( |  | ) |

Default constructor.

ClpNetworkMatrix::ClpNetworkMatrix | ( | int | numberColumns,
|  | const int * | head,
|  | const int * | tail |
| ) |  |  |

Constructor from two arrays.

virtual ClpNetworkMatrix::~ClpNetworkMatrix | ( |  | ) | `[virtual]`

Destructor.

ClpNetworkMatrix::ClpNetworkMatrix | ( | const ClpNetworkMatrix & |  | ) |

The copy constructor.

ClpNetworkMatrix::ClpNetworkMatrix | ( | const CoinPackedMatrix & |  | ) |

The copy constructor from an CoinNetworkMatrix.

ClpNetworkMatrix::ClpNetworkMatrix | ( | const ClpNetworkMatrix & | wholeModel,
|  | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns |
| ) |  |  |

Subset constructor (without gaps).

Duplicates are allowed and order is as given

## Member Function Documentation

virtual CoinPackedMatrix* ClpNetworkMatrix::getPackedMatrix | ( |  | ) | const`[virtual]`

Return a complete CoinPackedMatrix.

Implements ClpMatrixBase.

virtual bool ClpNetworkMatrix::isColOrdered | ( |  | ) | const`[inline, virtual]`

Whether the packed matrix is column major ordered or not.

Implements ClpMatrixBase.

Definition at line 27 of file ClpNetworkMatrix.hpp.

virtual CoinBigIndex ClpNetworkMatrix::getNumElements | ( |  | ) | const`[inline, virtual]`

Number of entries in the packed matrix.

Implements ClpMatrixBase.

Definition at line 31 of file ClpNetworkMatrix.hpp.

virtual int ClpNetworkMatrix::getNumCols | ( |  | ) | const`[inline, virtual]`

Number of columns.

Implements ClpMatrixBase.

Definition at line 35 of file ClpNetworkMatrix.hpp.

virtual int ClpNetworkMatrix::getNumRows | ( |  | ) | const`[inline, virtual]`

Number of rows.

Implements ClpMatrixBase.

Definition at line 39 of file ClpNetworkMatrix.hpp.

virtual const double* ClpNetworkMatrix::getElements | ( |  | ) | const`[virtual]`

A vector containing the elements in the packed matrix.

Note that there might be gaps in this list, entries that do not belong to any major-dimension vector. To get the actual elements one should look at this vector together with vectorStarts and vectorLengths.

Implements ClpMatrixBase.

virtual const int* ClpNetworkMatrix::getIndices | ( |  | ) | const`[inline, virtual]`

A vector containing the minor indices of the elements in the packed matrix.

Note that there might be gaps in this list, entries that do not belong to any major-dimension vector. To get the actual elements one should look at this vector together with vectorStarts and vectorLengths.

Implements ClpMatrixBase.

Definition at line 53 of file ClpNetworkMatrix.hpp.

virtual const CoinBigIndex* ClpNetworkMatrix::getVectorStarts | ( |  | ) | const`[virtual]`

Return a complete CoinPackedMatrix.

Implements ClpMatrixBase.

virtual const int* ClpNetworkMatrix::getVectorLengths | ( |  | ) | const`[virtual]`

The lengths of the major-dimension vectors.

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::deleteCols | ( | const int | numDel,
|  | const int * | indDel |
| ) |  |  | `[virtual]`

Delete the columns whose indices are listed in `indDel`.

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::deleteRows | ( | const int | numDel,
|  | const int * | indDel |
| ) |  |  | `[virtual]`

Delete the rows whose indices are listed in `indDel`.

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::appendCols | ( | int | number,
|  | const CoinPackedVectorBase *const * | columns |
| ) |  |  | `[virtual]`

Append Columns.

Reimplemented from ClpMatrixBase.

virtual void ClpNetworkMatrix::appendRows | ( | int | number,
|  | const CoinPackedVectorBase *const * | rows |
| ) |  |  | `[virtual]`

Append Rows.

Reimplemented from ClpMatrixBase.

virtual int ClpNetworkMatrix::appendMatrix | ( | int | number,
|  | int | type,
|  | const CoinBigIndex * | starts,
|  | const int * | index,
|  | const double * | element,
|  | int | numberOther = `-1` |
| ) |  |  | `[virtual]`

Append a set of rows/columns to the end of the matrix.

Returns number of errors i.e. if any of the new rows/columns contain an index that's larger than the number of columns-1/rows-1 (if numberOther>0) or duplicates If 0 then rows, 1 if columns

Reimplemented from ClpMatrixBase.

virtual ClpMatrixBase* ClpNetworkMatrix::reverseOrderedCopy | ( |  | ) | const`[virtual]`

Returns a new matrix in reverse order without gaps.

Reimplemented from ClpMatrixBase.

virtual CoinBigIndex ClpNetworkMatrix::countBasis | ( | const int * | whichColumn,
|  | int & | numberColumnBasic |
| ) |  |  | `[virtual]`

Returns number of elements in column part of basis.

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::fillBasis | ( | ClpSimplex * | model,
|  | const int * | whichColumn,
|  | int & | numberColumnBasic,
|  | int * | row,
|  | int * | start,
|  | int * | rowCount,
|  | int * | columnCount,
|  | CoinFactorizationDouble * | element |
| ) |  |  | `[virtual]`

Fills in column part of basis.

Implements ClpMatrixBase.

virtual CoinBigIndex* ClpNetworkMatrix::dubiousWeights | ( | const ClpSimplex * | model,
|  | int * | inputWeights |
| ) |  |  | const`[virtual]`

Given positive integer weights for each row fills in sum of weights for each column (and slack).

Returns weights vector

Reimplemented from ClpMatrixBase.

virtual void ClpNetworkMatrix::rangeOfElements | ( | double & | smallestNegative,
|  | double & | largestNegative,
|  | double & | smallestPositive,
|  | double & | largestPositive |
| ) |  |  | `[virtual]`

Returns largest and smallest elements of both signs.

Largest refers to largest absolute value.

Reimplemented from ClpMatrixBase.

virtual void ClpNetworkMatrix::unpack | ( | const ClpSimplex * | model,
|  | CoinIndexedVector * | rowArray,
|  | int | column |
| ) |  |  | const`[virtual]`

Unpacks a column into an CoinIndexedvector.

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::unpackPacked | ( | ClpSimplex * | model,
|  | CoinIndexedVector * | rowArray,
|  | int | column |
| ) |  |  | const`[virtual]`

Unpacks a column into an CoinIndexedvector in packed format Note that model is NOT const.

Bounds and objective could be modified if doing column generation (just for this variable)

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::add | ( | const ClpSimplex * | model,
|  | CoinIndexedVector * | rowArray,
|  | int | column,
|  | double | multiplier |
| ) |  |  | const`[virtual]`

Adds multiple of a column into an CoinIndexedvector You can use quickAdd to add to vector.

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::add | ( | const ClpSimplex * | model,
|  | double * | array,
|  | int | column,
|  | double | multiplier |
| ) |  |  | const`[virtual]`

Adds multiple of a column into an array.

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::releasePackedMatrix | ( |  | ) | const`[virtual]`

Allow any parts of a created CoinMatrix to be deleted.

Implements ClpMatrixBase.

virtual bool ClpNetworkMatrix::canDoPartialPricing | ( |  | ) | const`[virtual]`

Says whether it can do partial pricing.

Reimplemented from ClpMatrixBase.

virtual void ClpNetworkMatrix::partialPricing | ( | ClpSimplex * | model,
|  | double | start,
|  | double | end,
|  | int & | bestSequence,
|  | int & | numberWanted |
| ) |  |  | `[virtual]`

Partial pricing.

Reimplemented from ClpMatrixBase.

virtual void ClpNetworkMatrix::times | ( | double | scalar,
|  | const double * | x,
|  | double * | y |
| ) |  |  | const`[virtual]`

Return `y + A * scalar *x` in `y`.

Precondition:
  `x` must be of size `numColumns()`
  `y` must be of size `numRows()`

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::times | ( | double | scalar,
|  | const double * | x,
|  | double * | y,
|  | const double * | rowScale,
|  | const double * | columnScale |
| ) |  |  | const`[virtual]`

And for scaling.

Reimplemented from ClpMatrixBase.

virtual void ClpNetworkMatrix::transposeTimes | ( | double | scalar,
|  | const double * | x,
|  | double * | y |
| ) |  |  | const`[virtual]`

Return `y + x * scalar * A` in `y`.

Precondition:
  `x` must be of size `numRows()`
  `y` must be of size `numColumns()`

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::transposeTimes | ( | double | scalar,
|  | const double * | x,
|  | double * | y,
|  | const double * | rowScale,
|  | const double * | columnScale,
|  | double * | spare = `NULL` |
| ) |  |  | const`[virtual]`

And for scaling.

Reimplemented from ClpMatrixBase.

virtual void ClpNetworkMatrix::transposeTimes | ( | const ClpSimplex * | model,
|  | double | scalar,
|  | const CoinIndexedVector * | x,
|  | CoinIndexedVector * | y,
|  | CoinIndexedVector * | z |
| ) |  |  | const`[virtual]`

Return `x * scalar * A + y` in `z`.

Can use y as temporary array (will be empty at end) Note - If x packed mode - then z packed mode Squashes small elements and knows about ClpSimplex

Implements ClpMatrixBase.

virtual void ClpNetworkMatrix::subsetTransposeTimes | ( | const ClpSimplex * | model,
|  | const CoinIndexedVector * | x,
|  | const CoinIndexedVector * | y,
|  | CoinIndexedVector * | z |
| ) |  |  | const`[virtual]`

Return `x *A` in `z` but just for indices in y.

Note - z always packed mode

Implements ClpMatrixBase.

bool ClpNetworkMatrix::trueNetwork | ( |  | ) | const`[inline]`

Return true if really network, false if has slacks.

Definition at line 170 of file ClpNetworkMatrix.hpp.

ClpNetworkMatrix& ClpNetworkMatrix::operator= | ( | const ClpNetworkMatrix & |  | ) |

The copy constructor.

Reimplemented from ClpMatrixBase.

virtual ClpMatrixBase* ClpNetworkMatrix::clone | ( |  | ) | const`[virtual]`

Clone.

Implements ClpMatrixBase.

virtual ClpMatrixBase* ClpNetworkMatrix::subsetClone | ( | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns |
| ) |  |  | const`[virtual]`

Subset clone (without gaps).

Duplicates are allowed and order is as given

Reimplemented from ClpMatrixBase.

## Member Data Documentation

CoinPackedMatrix* ClpNetworkMatrix::matrix_`[mutable, protected]`

For fake CoinPackedMatrix.

Definition at line 215 of file ClpNetworkMatrix.hpp.

int* ClpNetworkMatrix::lengths_`[mutable, protected]`

For fake CoinPackedMatrix.

Definition at line 216 of file ClpNetworkMatrix.hpp.

int* ClpNetworkMatrix::indices_`[protected]`

Data -1, then +1 rows in pairs (row==-1 if one entry).

Definition at line 218 of file ClpNetworkMatrix.hpp.

int ClpNetworkMatrix::numberRows_`[protected]`

Number of rows.

Definition at line 220 of file ClpNetworkMatrix.hpp.

int ClpNetworkMatrix::numberColumns_`[protected]`

Number of columns.

Definition at line 222 of file ClpNetworkMatrix.hpp.

bool ClpNetworkMatrix::trueNetwork_`[protected]`

True if all entries have two elements.

Definition at line 224 of file ClpNetworkMatrix.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Smi-0.93.1/Clp/src/ClpNetworkMatrix.hpp